// NoOpClient.java, 21.09.2011, Robert Wappler

package com.example.noopws;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.namespace.QName;
import javax.xml.ws.Service;

import com.sun.xml.ws.Closeable;

public class NoOpClient {

	/**
	 * Change this, to meet your environment.
	 */
	private static final String SERVICE_URL =
		"http://192.168.3.108:8460/noopws-0.0.1-SNAPSHOT/no-op-ws?wsdl";

	/**
	 * <p>
	 * Note, that you need to have {@code keystore.jks} and
	 * {@code truststore.jks} in your working directory with the following
	 * entries:
	 * <ul>
	 * <li>{@code serverCert}: Public key of the server</li>
	 * <li>{@code clientKey}: Private key to use for authentication</li>
	 * </ul>
	 * The passwords are hardcoded to the value {@code changeit}.
	 * </p>
	 * <p>
	 * On the server side put the client's public key into
	 * {@code $domaindir/config/cacerts.jks} and the the server's key entry with
	 * alias {@code serverKey} into {@code $domaindir/config/keystore.jks}
	 * </p>
	 * 
	 * @param args ignored.
	 * @throws MalformedURLException if the Service URL could not be parsed.
	 */
	public static void main(String[] args) throws MalformedURLException {
		int i = 0;
		while (true) {
			if (++i % 10 == 0)
				System.out.println("Invocation Count: " + i);
			final NoOp noop =
				Service
					.create(
						new URL(SERVICE_URL),
						new QName("http://www.example.com/ns/noop-ws",
							"no-op-ws")).getPort(NoOp.class);

			noop.noop(System.currentTimeMillis());
			((Closeable) noop).close(); // workaround for WSIT-1260
		}
	}
}
